//********************************************************************************
// Here is all of the functions relating to the player-interface
// part of societies.
//
// Please note that this was written at 4 in the morning, and is probably not
// implemented as well as it could be. I would strongly suggest completely
// revising this chunk of code to make it flow a bit nicer.
//
// - Alister
//
// Aeonian Dreams:
//   telnet://dreams.game-host.org:4000
//
//********************************************************************************
//
//
// Options available for do_society:
//
// society list
// society info     <society>
// society apply    <society>
// society leave    <society>
// society setleave <free | restricted> <society> MODERATOR ONLY
// society setjoin  <free | restricted> <society> MODERATOR ONLY
// society expel    <person> <society>            MODERATOR ONLY
// society enroll   <person> <society>            MODERATOR ONLY
// society decline  <person> <society>            MODERATOR ONLY
// society makemod  <person> <society>            MODERATOR ONLY
// society create   <society>                     IMMORTAL ONLY
// society destroy  <society>                     IMMORTAL ONLY
// society reload   <society>                     IMMORTAL ONLY
//
ACMD(do_society) {

  char arg1[MAX_INPUT_LENGTH];
  char arg2[MAX_INPUT_LENGTH];

  if(ch == NULL || IS_NPC(ch))
    return;

  half_chop(argument, arg1, arg2);

  if(!*arg1) {
    show_society_info(ch);
    return;
  }


  // immortal-only commands
  if(GET_LEVEL(ch) >= LVL_SOCIETY_MOD) {

    if(!(strcmp(arg1, "create"))) {
      if(!*arg2)
	show_society_info(ch);
      else if(isSociety(arg2))
	send_to_char(ch, "There is already a society with the name, %s.\r\n", arg2);
      else {
	send_to_char(ch, "You create a society with the name, %s.\r\n", arg2);
	societyCreate(arg2);
      }
      return;
    }
    else if(!(strcmp(arg1, "destroy"))) {
      if(!*arg2)
	show_society_info(ch);
      else if(!isSociety(arg2))
	send_to_char(ch, "No society with the name %s exists.\r\n", arg2);
      else {
	send_to_char(ch, "You destroy %s.\r\n", arg2);
	societyDestroy(arg2);
      }
      return;
    }
    else if(!(strcmp(arg1, "reload"))) {
      if(!*arg2)
	show_society_info(ch);
      else if(!isSociety(arg2))
	send_to_char(ch, "No society with the name %s exists.\r\n", arg2);
      else if(societyReload(arg2))
	send_to_char(ch, "Data for %s has been reloaded.\r\n", arg2);
      else
	send_to_char(ch, "Failed to reload the data for %s.\r\n", arg2);
      return;
    }
  }

  // commands available to everybody
  if(!(strcmp(arg1, "apply"))) {
    if(!*arg2)
      show_society_info(ch);
    else if(!isSociety(arg2))
      send_to_char(ch, "%s is not a valid society.\r\n", arg2);
    else if(societyIsMember(arg2, ch))
      send_to_char(ch, "You are already a member of %s.\r\n", arg2);
    else if(societyOpenJoin(arg2)) {
      send_to_char(ch, "You are now a member of %s.\r\n", arg2);
      societyInduct(arg2, ch);
    }
    else {
      send_to_char(ch, "You apply to become a member of %s.\r\n", arg2);
      societyApply(arg2, ch);
    }
  }
  else if(!(strcmp(arg1, "leave"))) {
    if(!*arg2)
      show_society_info(ch);
    else if(!isSociety(arg2))
      send_to_char(ch, "%s is not a valid society.\r\n", arg2);
    else if(!societyIsMember(arg2, ch))
      send_to_char(ch, "You aren't even a member of %s.\r\n", arg2);
    else if(!(societyOpenLeave(arg2) || societyIsModerator(arg2, ch)))
      send_to_char(ch, "You must be expelled from %s in order to leave it.\r\n", arg2);
    else {
      send_to_char(ch, "You are no longer a member of %s.\r\n", arg2);
      societyExpel(arg2, ch);
    }
  }
  else if(!(strcmp(arg1, "expel"))) {
    struct char_data *vict;
    char arg3[MAX_INPUT_LENGTH];
    char name[MAX_INPUT_LENGTH];
    half_chop(arg2, name, arg3);

    if(!*arg3 || !*name)
      show_society_info(ch);
    else if(!isSociety(arg3))
      send_to_char(ch, "%s is not a valid society.\r\n", arg3);
    else if(!(societyIsModerator(arg3, ch) || GET_LEVEL(ch) >= LVL_SOCIETY_MOD))
      send_to_char(ch, "Only moderators can expel people from a society.\r\n");
    else if(societyOpenJoin(arg3))
      send_to_char(ch, "You can't kick someone out of an open-join society.\r\n");
    else if(!(vict = get_char_vis(ch, name, NULL, FIND_CHAR_WORLD)))
      send_to_char(ch, "%s is not around at the moment.\r\n", name);
    else if(!societyIsMember(arg3, vict))
      send_to_char(ch, "%s isn't even a member of %s.\r\n", GET_NAME(vict), arg3);
    else if(societyIsModerator(arg3, vict) && GET_LEVEL(ch) < LVL_SOCIETY_MOD)
      send_to_char(ch, "You do not have the power to kick a moderator out of %s.\r\n", arg3);
    else {
      send_to_char(ch, "You expel %s from %s.\r\n", GET_NAME(vict), arg3);
      send_to_char(vict, "You have been expelled from %s.\r\n", arg3);
      societyExpel(arg3, vict);
    }    
  }
  else if(!(strcmp(arg1, "decline"))) {
    struct char_data *vict;
    char arg3[MAX_INPUT_LENGTH];
    char name[MAX_INPUT_LENGTH];
    half_chop(arg2, name, arg3);

    if(!*arg3 || !*name)
      show_society_info(ch);
    else if(!isSociety(arg3))
      send_to_char(ch, "%s is not a valid society.\r\n", arg3);
    else if(!(societyIsModerator(arg3, ch) || GET_LEVEL(ch) >= LVL_SOCIETY_MOD))
      send_to_char(ch, "Only moderators can decline people from entering a society.\r\n");
    else if(!(vict = get_char_vis(ch, name, NULL, FIND_CHAR_WORLD)))
      send_to_char(ch, "%s is not around at the moment.\r\n", name);
    else if(!societyIsApplicant(arg3, vict))
      send_to_char(ch, "%s isn't applying to join %s.\r\n", GET_NAME(vict), arg3);
    else {
      send_to_char(ch, "You decline %s enterance to %s.\r\n", GET_NAME(vict), arg3);
      send_to_char(vict, "You have been declined enterance to %s.\r\n", arg3);
      societyDecline(arg3, vict);
    }    
  }
  else if(!(strcmp(arg1, "enroll"))) {
    struct char_data *vict;
    char arg3[MAX_INPUT_LENGTH];
    char name[MAX_INPUT_LENGTH];
    half_chop(arg2, name, arg3);

    if(!*arg3 || !*name)
      show_society_info(ch);
    else if(!isSociety(arg3))
      send_to_char(ch, "%s is not a valid society.\r\n", arg3);
    else if(!(societyIsModerator(arg3, ch) || GET_LEVEL(ch) >= LVL_SOCIETY_MOD))
      send_to_char(ch, "Only moderators can decline people from entering a society.\r\n");
    else if(!(vict = get_char_vis(ch, name, NULL, FIND_CHAR_WORLD)))
      send_to_char(ch, "%s is not around at the moment.\r\n", name);
    else if(!societyIsApplicant(arg3, vict))
      send_to_char(ch, "%s isn't applying to join %s.\r\n", GET_NAME(vict), arg3);
    else {
      send_to_char(ch, "You enroll %s into %s.\r\n", GET_NAME(vict), arg3);
      send_to_char(vict, "You have been enrolled into %s.\r\n", arg3);
      societyInduct(arg3, vict);
    }    
  }
  else if(!(strcmp(arg1, "makemod"))) {
    struct char_data *vict;
    char arg3[MAX_INPUT_LENGTH];
    char name[MAX_INPUT_LENGTH];
    half_chop(arg2, name, arg3);

    if(!*arg3 || !*name)
      show_society_info(ch);
    else if(!isSociety(arg3))
      send_to_char(ch, "%s is not a valid society.\r\n", arg3);
    else if(!(societyIsModerator(arg3, ch) || GET_LEVEL(ch) >= LVL_SOCIETY_MOD))
      send_to_char(ch, "Only moderators can make other people in a society a moderator.\r\n");
    else if(!(vict = get_char_vis(ch, name, NULL, FIND_CHAR_WORLD)))
      send_to_char(ch, "%s is not around at the moment.\r\n", name);
    else {
      send_to_char(ch, "You make %s a moderator of %s.\r\n", GET_NAME(vict), arg3);
      send_to_char(vict, "You have been made a moderator of %s.\r\n", arg3);
      societyMakeModerator(arg3, vict);
    } 
  }
  else if(!(strcmp(arg1, "setleave"))) {
    char name[MAX_INPUT_LENGTH];
    char setting[MAX_INPUT_LENGTH];
    half_chop(arg2, setting, name);

    if(!*name || !*setting)
      show_society_info(ch);
    else if(!isSociety(name))
      send_to_char(ch, "%s is not a valid society.\r\n", name);
    else if(!(societyIsModerator(name, ch) || GET_LEVEL(ch) >= LVL_SOCIETY_MOD))
      send_to_char(ch, "Only moderators can change that.\r\n");
    else if(!strcmp(setting, "free")) {
      send_to_char(ch, "Members of %s are free to leave as they please.\r\n", name);
      societySetOpenLeave(name, TRUE);
    } 
    else if(!strcmp(setting, "restricted")) {
      send_to_char(ch, "Members of %s can no longer leave as they please.\r\n", name);
      societySetOpenLeave(name, FALSE);
    }
    else
      send_to_char(ch, "Leave access my only be set to free or restricted.\r\n");
  }
  else if(!(strcmp(arg1, "setjoin"))) {
    char name[MAX_INPUT_LENGTH];
    char setting[MAX_INPUT_LENGTH];
    half_chop(arg2, setting, name);

    if(!*name || !*setting)
      show_society_info(ch);
    else if(!isSociety(name))
      send_to_char(ch, "%s is not a valid society.\r\n", name);
    else if(!(societyIsModerator(name, ch) || GET_LEVEL(ch) >= LVL_SOCIETY_MOD))
      send_to_char(ch, "Only moderators can change that.\r\n");
    else if(!strcmp(setting, "free")) {
      send_to_char(ch, "People may now freely join %s.\r\n", name);
      societySetOpenJoin(name, TRUE);
    } 
    else if(!strcmp(setting, "restricted")) {
      send_to_char(ch, "People must be enrolled into %s to join.\r\n", name);
      societySetOpenJoin(name, FALSE);
    }
    else
      send_to_char(ch, "Leave access my only be set to free or restricted.\r\n");
  }
  else if(!(strcmp(arg1, "list")))
    listSocieties(ch);
  else if(!(strcmp(arg1, "info"))) {
    if(!*arg2)
      show_society_info(ch);
    else
      listSocietyInfo(arg2, ch);
  }
  else
    show_society_info(ch);
}


void show_society_info(struct char_data *ch) {

  send_to_char(ch, "Commands are:\r\n"
		     "  society list\r\n"
		     "  society info     <society>\r\n"
		     "  society apply    <society>\r\n"
		     "  society join     <society>\r\n"
		     "  society leave    <society>\r\n"
		     "  society setjoin  <free | restricted> <society>\r\n"
		     "  society setleave <free | restricted> <society>\r\n"
		     "  society expel    <person> <society>\r\n"
		     "  society enroll   <person> <society>\r\n"
		     "  society decline  <person> <society>\r\n"
		     "  society makemod  <person> <society>\r\n");
  if(GET_LEVEL(ch) >= LVL_SOCIETY_MOD)
    send_to_char(ch, "  society create   <society>\r\n"
		     "  society destroy  <society>\r\n"
		     "  society reload   <society>\r\n");

}
